package gregapi;

import static gregapi.data.CS.F;
import static gregapi.data.CS.T;
import gregapi.data.TD;
import gregapi.item.IItemProjectile;
import gregapi.item.ItemMetaTool;
import gregapi.item.IItemProjectile.EntityProjectile;
import gregapi.oredict.IOreDictListenerItem;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.recipes.GT_ModHandler;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.Random;

import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import net.minecraftforge.event.entity.player.ArrowLooseEvent;
import net.minecraftforge.event.entity.player.ArrowNockEvent;
import net.minecraftforge.event.world.BlockEvent;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.TickEvent.WorldTickEvent;

/**
 * @author Gregorius Techneticies
 */
public abstract class GT_API_Proxy {
	public GT_API_Proxy() {
		MinecraftForge.EVENT_BUS.register(this);
		FMLCommonHandler.instance().bus().register(this);
	}
	
	@SubscribeEvent
	public void onWorldTick(WorldTickEvent aEvent) {
		if (!aEvent.world.isRemote) for (Object aEntity : aEvent.world.loadedEntityList) {
			if (aEntity instanceof EntityItem) {
				boolean tBreak = false;
				ItemStack aStack = ((EntityItem)aEntity).getEntityItem(), rStack = UT.Stacks.copy(aStack);
				OreDictItemData aData = OM.data(rStack);
				if (aData != null) {
					if (aData.mPrefix != null)
					for (IOreDictListenerItem tListener : aData.mPrefix.mListenersItem) {
						rStack = tListener.onTickWorld(aData.mPrefix, aData.mMaterial.mMaterial, rStack, (EntityItem)aEntity);
						if (!UT.Stacks.equal(rStack, aStack) || rStack.stackSize != aStack.stackSize) {tBreak = true; break;}
					}
					if (!tBreak && aData.mMaterial != null) for (OreDictMaterialStack tMaterial : aData.getAllMaterialStacks()) {
						if (tBreak) break;
						for (IOreDictListenerItem tListener : tMaterial.mMaterial.mListenersItem) {
							rStack = tListener.onTickWorld(aData.mPrefix, tMaterial.mMaterial, rStack, (EntityItem)aEntity);
							if (!UT.Stacks.equal(rStack, aStack) || rStack.stackSize != aStack.stackSize) {tBreak = true; break;}
						}
					}
					((EntityItem)aEntity).setEntityItemStack(rStack);
					if (rStack == null) ((EntityItem)aEntity).setDead();
				}
			}
		}
	}
	
	@SubscribeEvent
	public void onBlockHarvestingEvent(BlockEvent.HarvestDropsEvent aEvent) {
		if (aEvent.harvester != null) {
			ItemStack aStack = aEvent.harvester.getCurrentEquippedItem();
			if (aStack != null) {
				if (aStack.getItem() instanceof ItemMetaTool) {
					((ItemMetaTool)aStack.getItem()).onHarvestBlockEvent(aEvent.drops, aStack, aEvent.harvester, aEvent.block, aEvent.x, aEvent.y, aEvent.z, (byte)aEvent.blockMetadata, aEvent.fortuneLevel, aEvent.isSilkTouching, aEvent);
				}
				if (EnchantmentHelper.getEnchantmentLevel(Enchantment.fireAspect.effectId, aStack) > 2) {
					for (ItemStack tDrop : aEvent.drops) {
						ItemStack tSmeltingOutput = GT_ModHandler.getSmeltingOutput(tDrop, F, null);
						if (tSmeltingOutput != null) {
							tDrop.stackSize *= tSmeltingOutput.stackSize;
							tSmeltingOutput.stackSize = tDrop.stackSize;
							UT.Stacks.set(tDrop, tSmeltingOutput);
						}
					}
				}
			}
		}
	}
	
	@SubscribeEvent
	public void onEntitySpawningEvent(EntityJoinWorldEvent aEvent) {
		if (aEvent.entity != null && !aEvent.entity.worldObj.isRemote) {
			if (aEvent.entity instanceof EntityItem) ((EntityItem)aEvent.entity).setEntityItemStack(OM.get(((EntityItem)aEvent.entity).getEntityItem()));
		}
	}
	
	@SubscribeEvent
	public void onArrowNockEvent(ArrowNockEvent aEvent) {
		if (!aEvent.isCanceled() && UT.Stacks.valid(aEvent.result) && UT.Inventories.getProjectile(TD.Projectiles.ARROW, aEvent.entityPlayer.inventory) != null) {
			aEvent.entityPlayer.setItemInUse(aEvent.result, aEvent.result.getItem().getMaxItemUseDuration(aEvent.result));
            aEvent.setCanceled(T);
		}
	}
	
	@SubscribeEvent
	public void onArrowLooseEvent(ArrowLooseEvent aEvent) {
        ItemStack aArrow = UT.Inventories.getProjectile(TD.Projectiles.ARROW, aEvent.entityPlayer.inventory);
		if (!aEvent.isCanceled() && UT.Stacks.valid(aEvent.bow) && aArrow != null && aEvent.bow.getItem() instanceof ItemBow) {
            float tSpeed = aEvent.charge / 20.0F;
            tSpeed = (tSpeed * tSpeed + tSpeed * 2.0F) / 3.0F;
            
            if (tSpeed < 0.1) return;
            if (tSpeed > 1.0) tSpeed = 1.0F;
            
            EntityProjectile tArrowEntity = ((IItemProjectile)aArrow.getItem()).getProjectile(TD.Projectiles.ARROW, aArrow, aEvent.entityPlayer.worldObj, aEvent.entityPlayer, tSpeed * 2.0F);
            
            if (tSpeed >= 1.0F) tArrowEntity.setIsCritical(T);
            
            int
            tLevel = EnchantmentHelper.getEnchantmentLevel(Enchantment.power.effectId, aEvent.bow);
            if (tLevel > 0) tArrowEntity.setDamage(tArrowEntity.getDamage() + tLevel * 0.5D + 0.5D);
            tLevel = EnchantmentHelper.getEnchantmentLevel(Enchantment.punch.effectId, aEvent.bow);
            if (tLevel > 0) tArrowEntity.setKnockbackStrength(tLevel);
            tLevel = EnchantmentHelper.getEnchantmentLevel(Enchantment.flame.effectId, aEvent.bow);
            if (tLevel > 0) tArrowEntity.setFire(tLevel * 100);
            
            aEvent.bow.damageItem(1, aEvent.entityPlayer);
            aEvent.bow.getItem();
			aEvent.entityPlayer.worldObj.playSoundAtEntity(aEvent.entityPlayer, "random.bow", 1.0F, 1.0F / (new Random().nextFloat() * 0.4F + 1.2F) + tSpeed * 0.5F);
            
            tArrowEntity.canBePickedUp = 1;
            
            if (!aEvent.entityPlayer.capabilities.isCreativeMode) aArrow.stackSize--;
            if (aArrow.stackSize == 0) UT.Inventories.removeNullStacksFromInventory(aEvent.entityPlayer.inventory);
            
            if (!aEvent.entityPlayer.worldObj.isRemote) aEvent.entityPlayer.worldObj.spawnEntityInWorld(tArrowEntity);
            
            aEvent.setCanceled(T);
        }
	}
	
	public abstract void onPreLoad();
	public abstract void onLoad();
	public abstract void onPostLoad();
	
	/** works only ClientSide otherwise returns null */
	public EntityPlayer getThePlayer() {return null;}
	/** This means that Server specific Basefiles are definitely existing! Not if the World is actually server side or not! */
	public boolean isServerSide() {return false;}
	/** This means that Client specific Basefiles are definitely existing! Not if the World is actually client side or not! */
	public boolean isClientSide() {return false;}
}