package gregapi.render;

import net.minecraft.block.Block;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
public interface IRenderedBlockObject {
	/** @return the Textures rendered by {@link RendererBlockTextured} */
    @SideOnly(Side.CLIENT)
	public ITexture getTexture(Block aBlock, int aRenderPass, byte aSide);
	
	/** sets the Block Size rendered by {@link RendererBlockTextured} return false for letting it select the normal Block Bounds. */
    @SideOnly(Side.CLIENT)
	public boolean setBlockBounds(Block aBlock, int aRenderPass, byte aSide);
    
    /** gets the Amount of Render Passes for this TileEntity or similar Handler. */
    @SideOnly(Side.CLIENT)
    public int getRenderPasses(Block aBlock, byte aSide);
}